///////////////////////////////////////////////////////////////////////////////////
//by
///////////////////////////////////////////////////////////////////////////////////
float Script : STANDARDSGLOBAL <
	string ScriptOutput = "color";
	string ScriptClass = "scene";
	string ScriptOrder = "postprocess";
> = 0.8;
///////////////////////////////////////////////////////////////////////////////////



#define ScnScale 1.0

static float AABlurScale=0.5;
static float AAScale=0.0;

#define SAMPNUMSSAO2 32
#define SAMPNUMS 16
#define SAMPNUMS2 8
#define SAMPNUMSS 16
#define SAMPNUMSS2 8



static float F0Def = 0.02;
static float F0MetalDef = 1.0;

float3   LightSpecular     : SPECULAR  < string Object = "Light"; >;
static float3 LightColor = LightSpecular*5;
//e

float3 SkyColor1: CONTROLOBJECT < string name = "KrSSCon.pmx"; string item = ""; >;
float3 GroundColor1: CONTROLOBJECT < string name = "KrSSCon.pmx"; string item = "nʊ"; >;
float EnvDefColor0: CONTROLOBJECT < string name = "KrSSCon.pmx"; string item = "0"; >;
float EnvAllColor0: CONTROLOBJECT < string name = "KrSSCon.pmx"; string item = "S0"; >;
float SRainRate : CONTROLOBJECT < string name = "KrSSCon.pmx"; string item = "J"; >;

static float3 SkyColor=(0.05*(1.0-EnvDefColor0)+SkyColor1)*LightColor*(1.0-EnvAllColor0);
static float3 GroundColor=(0.05*(1.0-EnvDefColor0)+GroundColor1)*LightColor*(1.0-EnvAllColor0);




float3    LightDirL1   : DIRECTION < string Object = "Light"; >;

float3   LightDirection    : DIRECTION < string Object = "Light"; > ;
static float3 LightDir = normalize(-LightDirection);

float3   CameraPosition    : POSITION  < string Object = "Camera"; >;
float3   CameraDirection    : DIRECTION < string Object = "Camera"; >;



float4x4 ViewProjMatrix      : VIEWPROJECTION;
float4x4 ViewMatrix      : VIEW;
float4x4 InvViewMatrix  	: VIEWINVERSE;
float4x4 ProjMatrix		: PROJECTION;
static float2 scaleProj = float2(1.0 / ProjMatrix._11_22);


float2 ViewportSize : VIEWPORTPIXELSIZE;
static float2 ViewportOffset = (float2(0.5,0.5)/ViewportSize);
static float2 SampStep = (float2(1, 1) / ViewportSize);
static float2 SampStep2 = (float2(0.5, 0.5) / ViewportSize) * ViewportSize.x / 2560;

float ClearDepth = 1.0;
float4 ClearColor= float4(1,1,1,0);



shared texture2D MaterialKrss2lMapRT: OFFSCREENRENDERTARGET <
	float2 ViewPortRatio = { ScnScale,ScnScale };
string Description = "ގ蓖1";
string Format = "A32B32G32R32F";
float4 ClearColor = { 0, 0, 0, 0 };
float ClearDepth = 1.0;
bool AntiAlias = false;
int Miplevels = 1;
string DefaultEffect =
"self = hide;"
"* =Material/Base/Material.fx;";
>;
sampler MaterialKrSSLSamp = sampler_state {
	Texture = (MaterialKrss2lMapRT);
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};



shared texture2D WPosKrMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { ScnScale,ScnScale };
	int MipLevels = 1;
string Format = "A32B32G32R32F";
>;
sampler2D WPosSamp = sampler_state {
	texture = <WPosKrMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = MIRROR;
	AddressV = MIRROR;
};

shared texture2D NormalDepthKrMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { ScnScale,ScnScale };
int MipLevels = 1;
string Format = "A32B32G32R32F";
>;
sampler2D NormalDepthSamp = sampler_state {
	texture = <NormalDepthKrMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

shared texture2D AlbedoMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { ScnScale,ScnScale };
int MipLevels = 1;
string Format = "A32B32G32R32F";
>;
sampler2D AlbedoSamp = sampler_state {
	texture = <AlbedoMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

shared texture2D MatAMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { ScnScale,ScnScale };
int MipLevels = 1;
string Format = "A32B32G32R32F";
>;
sampler2D MatASamp = sampler_state {
	texture = <MatAMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};



shared texture2D LumiMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { ScnScale,ScnScale };
int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D LumiSamp = sampler_state {
	texture = <LumiMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};



texture2D DepthBuffer : RENDERDEPTHSTENCILTARGET <
	float2 ViewPortRatio = { ScnScale,ScnScale };
	string Format = "D24S8";
>;

float3	noise3(float3 p) {

	float3 p2 = (p);
	float3 N = 0;
	
	N.x = 	sin(p2.x*4+sin(p2.x+p2.y*0.52)*3+sin(p2.x*2+p2.z+100.5555)*5+1000);
	N.y = 	sin(p2.y*4+sin(p2.y+p2.z*0.51)*3+sin(p2.y*2+p2.x+100.5678)*5+1000);
	N.z = 	sin(p2.z*4+sin(p2.z+p2.x*0.54)*3+sin(p2.z*2+p2.y+100.5885)*5+1000);

	return N;

}
////////////////////////////////////////////////////////////////////////////////////////////////
struct VS_OUTPUT {
	float4 Pos            : POSITION;
	float2 Tex            : TEXCOORD0;
};

VS_OUTPUT VS_passDraw(float4 Pos : POSITION, float4 Tex : TEXCOORD0) {
	VS_OUTPUT Out = (VS_OUTPUT)0;

	Out.Pos = Pos;
	Out.Tex = Tex + ViewportOffset;
	return Out;
}

////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_MatA(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color = tex2D(MaterialKrSSLSamp, Tex);
	float3 Mat = fmod(trunc(abs(Color.rgb))*0.01,1.0);
	float3 Mat2 = fmod(trunc(trunc(abs(Color.rgb))*0.01),10.0)*0.1;
	float4 RMSS = float4(Mat,Mat2.x);

	return RMSS;
}
////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_ND(float2 Tex: TEXCOORD0) : COLOR
{
	float4 ND = tex2D(MaterialKrSSLSamp, Tex);
	ND.rgb = normalize(fmod(ND.rgb, 1.0));
	ND.a=abs(ND.a);
	return ND;
}
////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_Albedo(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color = tex2D(MaterialKrSSLSamp, Tex);
	
	Color.rgb = trunc(abs(Color.rgb)*0.001)*0.01;
	
	Color.a=1.0;
	
	return Color;
}
////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_Lumi(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color = tex2D(MaterialKrSSLSamp, Tex);
	
	Color.rgb = trunc(abs(Color.rgb)*0.001)*0.01;
	
	Color.rgb=normalize(Color.rgb)*max(0.0,length(Color.rgb)-2);
	Color.a=1.0;
	
	return Color;
}
////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_PosW(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color = 1.0;
	float Depth = abs(tex2D(MaterialKrSSLSamp, Tex).a);

	Depth=lerp(10000,Depth,step(0.00001,Depth));

	float2 PPos = (Tex - 0.5) * float2(2.0, -2.0);
	float3 VPos = float3(PPos.xy * scaleProj, 1) * Depth;
	Color.rgb = mul(float4(VPos, 1), InvViewMatrix).xyz;
	Color.a = distance(Color.rgb,CameraPosition);// Depth;


	return Color;
}

////////////////////////////////////////////////////////////////////////////////////////////////




technique FILTER <
	string Script =

	"RenderColorTarget0=MatAMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=MatA;"

	"RenderColorTarget0=WPosKrMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=PosW;"

	"RenderColorTarget0=NormalDepthKrMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=ND;"
	
	"RenderColorTarget0=AlbedoMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=Albedo;"
	
	"RenderColorTarget0=LumiMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"Pass=Lumi;"
	


	"RenderColorTarget0=;"
	"RenderDepthStencilTarget=;"
	"ScriptExternal=Color;"

	;

> {
	pass MatA < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_MatA();
	}
	pass PosW < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_PosW();
	}
	pass ND < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_ND();
	}
	pass Albedo < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_Albedo();
	}
	pass Lumi < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_Lumi();
	}
}
////////////////////////////////////////////////////////////////////////////////////////////////
