// p[^錾
#include"yureHeader.fx"
//}eAp[^
static float Roughness=0.4;//\ʂ̑e
static float Metalic=0.0;//ۂ
static float Specular=0.5;//XyL
static float3 RMS=saturate(float3(Roughness,Metalic,Specular));

static float SSSRate=0.0;
static float Empty=0.2;
static float Empty2=0.0;
static float3 SLM=saturate(float3(SSSRate,Empty,Empty2));

//I[gm[}}bvp[^
static float ANSize=01.0/1024;
float ANScale=0.5;


// @ϊs
float4x4 WorldViewProjMatrix      : WORLDVIEWPROJECTION;
float4x4 ViewProjMatrix      : VIEWPROJECTION;
float4x4 WorldViewMatrix      : WORLDVIEW;
float4x4 ViewMatrix      : VIEW;
float4x4 WorldMatrix              : WORLD;
float4x4 ProjMatrix		: PROJECTION;

float3   CameraPosition    : POSITION  < string Object = "Camera"; >;
float3   CameraDirection   : DIRECTION < string Object = "Camera"; >;


float3   LightDirection   : DIRECTION < string Object = "Light"; >;
float3   LightSpecular     : SPECULAR  < string Object = "Light"; >;
static float3 LightColor = LightSpecular*1.6;


float4   MaterialDiffuse   : DIFFUSE  < string Object = "Geometry"; >;
float3   MaterialAmbient   : AMBIENT  < string Object = "Geometry"; >;
float3   MaterialEmmisive  : EMISSIVE < string Object = "Geometry"; >;
float    SpecularPower : SPECULARPOWER < string Object = "Geometry"; >;

static float3 MColor2= MaterialEmmisive+MaterialAmbient;
static float3 MColor=pow(MColor2,max(1.0,SpecularPower*0.01));

// eNX`ގ[tl
float4   TextureAddValue   : ADDINGTEXTURE;
float4   TextureMulValue   : MULTIPLYINGTEXTURE;
float4   SphereAddValue    : ADDINGSPHERETEXTURE;
float4   SphereMulValue    : MULTIPLYINGSPHERETEXTURE;

// MMD{sampler㏑Ȃ߂̋LqłB폜sB
sampler MMDSamp0 : register(s0);
sampler MMDSamp1 : register(s1);
sampler MMDSamp2 : register(s2);


// XN[TCY
float2 ViewportSize : VIEWPORTPIXELSIZE;
static const float2 ViewportOffset = (float2(0.5, 0.5) / ViewportSize);

// IuWFNg̃eNX`
texture ObjectTexture: MATERIALTEXTURE;
sampler ObjTexSampler = sampler_state {
	texture = <ObjectTexture>;
	MINFILTER = LINEAR;
	MAGFILTER = LINEAR;
	MIPFILTER =NONE;
	ADDRESSU = CLAMP;
	ADDRESSV = WRAP;
};

// XtBA}bṽeNX`
texture ObjectSphereMap: MATERIALSPHEREMAP;
sampler ObjSphareSampler = sampler_state {
    texture = <ObjectSphereMap>;
    MINFILTER = LINEAR;
    MAGFILTER = LINEAR;
    MIPFILTER = LINEAR;
    ADDRESSU  = WRAP;
    ADDRESSV  = WRAP;
};

float3x3 compute_tangent_frame(float3 Normal, float3 View, float2 UV)
{
  float3 dp1 = ddx(View);
  float3 dp2 = ddy(View);
  float2 duv1 = ddx(UV);
  float2 duv2 = ddy(UV);

  float3x3 M = float3x3(dp1, dp2, cross(dp1, dp2));
  float2x3 inverseM = float2x3(cross(M[1], M[2]), cross(M[2], M[0]));
  float3 Tangent = mul(float2(duv1.x, duv2.x), inverseM);
  float3 Binormal = mul(float2(duv1.y, duv2.y), inverseM);

  return float3x3(normalize(Tangent), normalize(Binormal), Normal);
}
////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////
// IuWFNg`iZtVhEOFFj

struct VS_OUTPUT
{
	float4 Pos      : POSITION;
	float3 Eye    	: TEXCOORD0;
	float2 Tex	    : TEXCOORD1;
	float4 PosW     : TEXCOORD2;
	float4 ScreenTex: TEXCOORD3;
	float3 Normal   : TEXCOORD4;
	float3 Eye2     : TEXCOORD5;
};

// _VF[_
VS_OUTPUT Basic_VS(float4 Pos : POSITION, float3 Normal : NORMAL, float2 Tex : TEXCOORD0)
{
	VS_OUTPUT Out = (VS_OUTPUT)0;
    Pos.xyz+=YurePos(Tex,Pos.xyz);

	Out.PosW = mul(Pos, WorldMatrix);

	Out.Normal =Normal;// normalize(mul(Normal, (float3x3)WorldMatrix));

	Out.Pos = mul(Out.PosW,ViewProjMatrix);

	Out.Eye = mul(Out.PosW, ViewMatrix).xyz;
	Out.ScreenTex = Out.Pos;
	Out.Tex = Tex;


	Out.Eye2 = CameraPosition-Out.PosW.xyz;

	return Out;
}

// sNZVF[_
float4 Basic_PS(VS_OUTPUT IN, float VFace : VFACE,uniform bool useTexture) : COLOR0
{
	float4 Color=1.0;
	float4 STex = IN.ScreenTex;
	STex.xy /= STex.w;
	STex.x = (1.0f + STex.x) * 0.5f;
	STex.y = (1.0f - STex.y) * 0.5f;
	STex.xy += ViewportOffset;
	
	Color.rgb *=saturate(min(length(MColor),1.8)*normalize(MColor));
	float4 TexColor = tex2D(ObjTexSampler, IN.Tex);
	if ( useTexture ) {
	 TexColor.rgb = lerp(1, TexColor.rgb * TextureMulValue.rgb + TextureAddValue.rgb, TextureMulValue.a + TextureAddValue.a);
	Color *= TexColor;
	}
	Color.a *=MaterialDiffuse.a;
	clip(Color.a - 0.1);
	float3 Normal = normalize(mul(IN.Normal, (float3x3)WorldMatrix));
	Normal=Normal*VFace;

 //Fς
	float3 ColorB=float3(Color.r*1.3,Color.g*1.3,Color.b*0.9);
	float GreenRate=saturate(Color.g*3-Color.b*2-Color.r);
	Color.rgb=lerp(Color.rgb,ColorB.rgb,GreenRate);

	Color.rgb*=max(1.0,SpecularPower-99.0);
	


	//I[gm[}}bv

	float4 TexColorY1 = tex2D(ObjTexSampler, IN.Tex + float2(0, ANSize));
	float4 TexColorY2 = tex2D(ObjTexSampler, IN.Tex + float2(0, -ANSize));
	float4 TexColorX1 = tex2D(ObjTexSampler, IN.Tex + float2(ANSize, 0));
	float4 TexColorX2 = tex2D(ObjTexSampler, IN.Tex + float2(-ANSize, 0));

	float4 TY = (TexColorY1 - TexColorY2);
	float4 TX = (TexColorX1 - TexColorX2);

	float NY = TY.r + TY.g + TY.b + TY.a;
	float NX = TX.r + TX.g + TX.b + TX.a;
	
	float3 NormalT1 = normalize(float3(NX, NY, 0.5));
	float3 EyeVec = normalize(IN.Eye2);
	float3x3 tangentFrame = compute_tangent_frame(Normal, EyeVec, IN.Tex);
	float3 Normal2 = normalize(mul(normalize(NormalT1.rgb), tangentFrame));

	Normal = normalize(lerp(Normal,Normal2,ANScale));
	RMS.b*=Color.a;
	//GR[h
	SLM=min(9,SLM*10);
	RMS=min(0.99,RMS);
	Color.rgb = (trunc(Color.rgb*100)*1000+trunc(SLM)*100+trunc(RMS*100)+abs(Normal*0.99))*(step(0.0,Normal)*2.0-1.0);
	
	Color.a=IN.Eye.z+(1.0-Color.a)*0.05;
	
	return Color;
}

// IuWFNg`peNjbN
technique MainTec < string MMDPass = "object"; bool UseTexture = true;> {
	pass DrawObject
	{
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 Basic_VS();
		PixelShader = compile ps_3_0 Basic_PS(true);
	}
}
technique MainTec2 < string MMDPass = "object"; bool UseTexture = false;> {
	pass DrawObject
	{
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 Basic_VS();
		PixelShader = compile ps_3_0 Basic_PS(false);
	}
}
// IuWFNg`peNjbN
technique MainTecBS  < string MMDPass = "object_ss"; bool UseTexture = true;> {
	pass DrawObject {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 Basic_VS();
		PixelShader = compile ps_3_0 Basic_PS(true);
	}
}
technique MainTecBS2 < string MMDPass = "object_ss"; bool UseTexture = false;> {
	pass DrawObject
	{
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 Basic_VS();
		PixelShader = compile ps_3_0 Basic_PS(false);
	}
}
technique EdgeTec < string MMDPass = "edge"; > {

}
technique ShadowTech < string MMDPass = "shadow";  > {

}
technique ZplotTec	< string MMDPass = "zplot"; >{

}

///////////////////////////////////////////////////////////////////////////////////////////////