///////////////////////////////////////////////////////////////////////////////////
//KrFilterGtFNg
//by
///////////////////////////////////////////////////////////////////////////////////
float Script : STANDARDSGLOBAL <
	string ScriptOutput = "color";
	string ScriptClass = "scene";
	string ScriptOrder = "postprocess";
> = 0.8;

float Tr : CONTROLOBJECT < string name = "(self)"; string item = "Tr"; >;
float X : CONTROLOBJECT < string name = "(self)"; string item = "X"; >;
float Y : CONTROLOBJECT < string name = "(self)"; string item = "Y"; >;
float Z : CONTROLOBJECT < string name = "(self)"; string item = "Z"; >;
float Rx : CONTROLOBJECT < string name = "(self)"; string item = "Rx"; >;


float2 ViewportSize : VIEWPORTPIXELSIZE;
static float2 ViewportOffset = (float2(0.5,0.5)/ViewportSize);
static float2 SampStep = (float2(0.5,0.5)/ViewportSize);

float ClearDepth = 1.0;
float4 ClearColor= float4(1,1,1,0);

texture2D DepthBuffer : RENDERDEPTHSTENCILTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
	string Format = "D24S8";
>;

texture2D ScnMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
	int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D ScnSamp = sampler_state {
	texture = <ScnMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};
////////////////////////////////////////////////////////////////////////////////////////////////
struct VS_OUTPUT {
	float4 Pos            : POSITION;
	float2 Tex            : TEXCOORD0;
};

VS_OUTPUT VS_passDraw(float4 Pos : POSITION, float4 Tex : TEXCOORD0) {
	VS_OUTPUT Out = (VS_OUTPUT)0;

	Out.Pos = Pos;
	Out.Tex = Tex + ViewportOffset;
	return Out;
}


////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_passFilter(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color=tex2D(ScnSamp, Tex);
	
	float3 rgbG=float3(0.2126,0.7152,0.0722);
	
	
	float3 FColor=tex2D(ScnSamp,Tex);
	float2 SampStepB=SampStep;
	float3 FColor1=tex2D(ScnSamp,Tex+float2(SampStepB.x,0));
	float3 FColor2=tex2D(ScnSamp,Tex+float2(-SampStepB.x,0));
	float3 FColor3=tex2D(ScnSamp,Tex+float2(0,SampStepB.y));
	float3 FColor4=tex2D(ScnSamp,Tex+float2(0,-SampStepB.y));

	float3 FColor5=tex2D(ScnSamp,Tex+float2(SampStepB.x,SampStepB.y));
	float3 FColor6=tex2D(ScnSamp,Tex+float2(SampStepB.x,-SampStepB.y));
	float3 FColor7=tex2D(ScnSamp,Tex+float2(-SampStepB.x,SampStepB.y));
	float3 FColor8=tex2D(ScnSamp,Tex+float2(-SampStepB.x,-SampStepB.y));


float4 array[9]={

float4 (FColor.xyz,dot(FColor.xyz,rgbG)),
float4 (FColor1.xyz,dot(FColor1.xyz,rgbG)),
float4 (FColor2.xyz,dot(FColor2.xyz,rgbG)),
float4 (FColor3.xyz,dot(FColor3.xyz,rgbG)),
float4 (FColor4.xyz,dot(FColor4.xyz,rgbG)),
float4 (FColor5.xyz,dot(FColor5.xyz,rgbG)),
float4 (FColor6.xyz,dot(FColor6.xyz,rgbG)),
float4 (FColor7.xyz,dot(FColor7.xyz,rgbG)),
float4 (FColor8.xyz,dot(FColor8.xyz,rgbG)),

};
	[unroll]
	for (int i= 0; i < 8; i += 1) {

		[unroll]
		for (int j = 0; j < 8-i; j += 1) {

			float4 P1=array[i+1];
			array[i+1]=lerp(array[i],array[i+1],step(array[i].a,array[i+1].a));
			array[i]=lerp(array[i],P1,step(P1.a,array[i].a));

			//float4 tmp=array[i+1];
			//array[i+1]=lerp(array[i],array[i+1],step(array[i+1].a,array[i].a));
			//array[i]=lerp(tmp,array[i],step(array[i+1].a,array[i].a));
		}
	}

	Color.rgb =lerp(Color.rgb,array[4].rgb,Tr);
	return Color;
}
////////////////////////////////////////////////////////////////////////////////////////////////

technique FILTER <
	string Script =

	"RenderColorTarget0=ScnMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"ClearSetColor=ClearColor;"
	"ClearSetDepth=ClearDepth;"
	"Clear=Color;"
	"Clear=Depth;"
	"ScriptExternal=Color;"

	"RenderColorTarget0=;"
	"RenderDepthStencilTarget=;"
	"ClearSetColor=ClearColor;"
	"ClearSetDepth=ClearDepth;"
	"Clear=Color;"
	"Clear=Depth;"
	"Pass=Filter;"

	;

> {
	pass Filter < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_passFilter();
	}
}
////////////////////////////////////////////////////////////////////////////////////////////////
