float Script : STANDARDSGLOBAL <
    string ScriptOutput = "color";
    string ScriptClass = "scene";
    string ScriptOrder = "postprocess";
> = 0.8;

float Tr : CONTROLOBJECT < string name = "(self)"; string item = "Tr"; >;	
float Scale : CONTROLOBJECT < string name = "(self)"; string item = "Si"; >;

static float Si=Scale*0.1;
float LengthMax = 1.0;
static float BlurScale = Si;
static float BlurScale2 = Si;
float2 ViewportSize : VIEWPORTPIXELSIZE;

static float2 ViewportOffset = (float2(0.5,0.5)/ViewportSize);
static float2 SampStep = (float2(0.5,0.5) / ViewportSize)*2;

float3	LightPosition	: POSITION  < string Object = "Light"; >;
float3	LightDirection	: DIRECTION < string Object = "Light"; >;
float3	LightDiffuse	: DIFFUSE   < string Object = "Light"; >;
float3	LightAmbient	: AMBIENT   < string Object = "Light"; >;

float3   CameraPosition    : POSITION  < string Object = "Camera"; >;
float3   CameraDirection   : DIRECTION < string Object = "Camera"; >;
float4x4 WorldViewProjMatrix      : WORLDVIEWPROJECTION;
float4x4 ViewProjMatrix           : VIEWPROJECTION;

#define SAMPNUM 32

float ClearDepth  = 1.0;
float4 ClearColor = float4(0, 0, 0, 1);


shared texture2D NormalDepthKrMap : RENDERCOLORTARGET ;
sampler2D NormalDepthSamp = sampler_state {
	texture = <NormalDepthKrMap>;
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};




shared texture2D MaterialKrss2lMapRT: OFFSCREENRENDERTARGET ;
sampler MaterialKrSSLSamp = sampler_state {
	Texture = (MaterialKrss2lMapRT);
	MinFilter = POINT;
	MagFilter = POINT;
	MipFilter = POINT;
	AddressU = CLAMP;
	AddressV = CLAMP;
};


texture2D DepthBuffer : RENDERDEPTHSTENCILTARGET <
    float2 ViewPortRatio = {1.0,1.0};
    string Format = "D24S8";
>;

texture2D ScnMap : RENDERCOLORTARGET <
    float2 ViewPortRatio = {1.0,1.0};
    int MipLevels = 1;
    string Format = "A16B16G16R16F" ;
>;
sampler2D ScnSamp = sampler_state {
    texture = <ScnMap>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = LINEAR;
    AddressU  = MIRROR;
    AddressV = MIRROR;
};


////////////////////////////////////////////////////////////////////////////////////////////////
struct VS_OUTPUT {
	float4 Pos            : POSITION;
	float2 Tex            : TEXCOORD0;
};

VS_OUTPUT VS_passDraw( float4 Pos : POSITION, float4 Tex : TEXCOORD0 ) {
    VS_OUTPUT Out = (VS_OUTPUT)0; 
    
    Out.Pos = Pos;
    Out.Tex = Tex + ViewportOffset;
    return Out;
}

float4 PS_passDraw2(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color = tex2D(ScnSamp, Tex);
	float2 SampStepRate = SampStep;

	//float ColorSampX0D = tex2D(NormalDepthSamp, Tex + float2(-SampStepRate.x, 0.0)).a;
	//float ColorSampY0D = tex2D(NormalDepthSamp, Tex + float2(0.0, -SampStepRate.y)).a;
	//float ColorSampY2D = tex2D(NormalDepthSamp, Tex + float2(0.0, SampStepRate.y)).a;
	//float ColorSampX2D = tex2D(NormalDepthSamp, Tex + float2(SampStepRate.x, 0.0)).a;

	//float XEdge = ColorSampX2D - ColorSampX0D;
	//float YEdge = ColorSampY2D - ColorSampY0D;


	float MatKrSSL = tex2D(MaterialKrSSLSamp, Tex).y;
	float MatNum=fmod(trunc(trunc(abs(MatKrSSL))*0.01),10.0);
	float RFlag = step(2.5, MatNum)*step(MatNum, 3.5);



	MatKrSSL = tex2D(MaterialKrSSLSamp, Tex + float2(-SampStepRate.x, 0.0)).y;
	MatNum=fmod(trunc(trunc(abs(MatKrSSL))*0.01),10.0);
	RFlag += step(2.5, MatNum)*step(MatNum, 3.5);

	MatKrSSL = tex2D(MaterialKrSSLSamp, Tex + float2(SampStepRate.x, 0.0)).y;
	MatNum=fmod(trunc(trunc(abs(MatKrSSL))*0.01),10.0);
	RFlag += step(2.5, MatNum)*step(MatNum, 3.5);
	
	MatKrSSL = tex2D(MaterialKrSSLSamp, Tex + float2(0.0,SampStepRate.y)).y;
	MatNum=fmod(trunc(trunc(abs(MatKrSSL))*0.01),10.0);
	RFlag += step(2.5, MatNum)*step(MatNum, 3.5);

	MatKrSSL = tex2D(MaterialKrSSLSamp, Tex + float2(0.0,-SampStepRate.y)).y;
	MatNum=fmod(trunc(trunc(abs(MatKrSSL))*0.01),10.0);
	RFlag += step(2.5, MatNum)*step(MatNum, 3.5);
	
	//RFlag=saturate(RFlag)*8;
	//float2 EdgeRate=normalize(float2( YEdgeD,-XEdgeD))*min(0.1,length(float2(YEdgeD, XEdgeD)*(RFlag+1.0)))*BlurScale2*(1.0+RFlag);



	float3 ColorSampX0 = tex2D(ScnSamp, Tex + float2(-SampStepRate.x, 0.0)).rgb;
	float3 ColorSampY0 = tex2D(ScnSamp, Tex + float2(0.0, -SampStepRate.y)).rgb;
	float3 ColorSampY2 = tex2D(ScnSamp, Tex + float2(0.0, SampStepRate.y)).rgb;
	float3 ColorSampX2 = tex2D(ScnSamp, Tex + float2(SampStepRate.x, 0.0)).rgb;

	float XEdge = length(ColorSampX2) - length(ColorSampX0);
	float YEdge = length(ColorSampY2) - length(ColorSampY0);
	float2 XYNEdge=normalize(float2(-YEdge,XEdge));
	float2 XYNEdge2=lerp(XYNEdge,0.000001,step(abs(XYNEdge.xy),0.000001));

	RFlag=saturate(RFlag);
	float2 EdgeRate=XYNEdge*RFlag*BlurScale2*0.1*min(16.0,1.0+max(abs(XYNEdge2.x/XYNEdge2.y),abs(XYNEdge2.y/XYNEdge2.x)));//*max(0.5,(pow(YEdgeD/XEdgeD,2)+pow(XEdgeD/YEdgeD,2))*0.005);

	
	
	float2 SampStepRateR = SampStep*EdgeRate;
	float3 BlurColor = 0.0;
	float e, n = 0;
	[unroll]
	for (int i = -SAMPNUM; i <= SAMPNUM; i += 1) {
		e = exp(-pow((float)i / (SAMPNUM / 2.0), 2) / 2);
		float2 SampStepTex = i*SampStepRateR;
		BlurColor += tex2D(ScnSamp, Tex + SampStepTex).rgb * e;
		n += e;
	}
	Color.rgb = BlurColor / n;


	return Color;
}

////////////////////////////////////////////////////////////////////////////////////////////////
technique AA <
	string Script =

	"RenderColorTarget0=ScnMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"ClearSetColor=ClearColor;"
	"ClearSetDepth=ClearDepth;"
	"Clear=Color;"
	"Clear=Depth;"
	"ScriptExternal=Color;"

	"RenderColorTarget0=;"
	"RenderDepthStencilTarget=;"
	"ClearSetColor=ClearColor;"
	"ClearSetDepth=ClearDepth;"
	"Clear=Color;"
	"Clear=Depth;"
	"Pass=Draw2;"
	;


> {
	pass Draw2 < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_passDraw2();
	}
}
////////////////////////////////////////////////////////////////////////////////////////////////
