#include"yureHeader2.fx"
float4x4 SMat: CONTROLOBJECT < string name = "MainSystem.x"; >;
static float3 SPos = float3(SMat._41, SMat._42, SMat._43);
float ShSi2 : CONTROLOBJECT < string name = "MainSystem.x"; string item = "Si"; >;

static float ShSi = ShSi2*0.1;


float3    LightDirL1   : DIRECTION < string Object = "Light"; >;


float3   LightDirection    : DIRECTION < string Object = "Light"; >;
static float3 LightDir = normalize(-LightDirection);

float3   CameraPosition    : POSITION  < string Object = "Camera"; >;
float3   CameraDirection    : DIRECTION < string Object = "Camera"; >;

static float3 PosL = SPos  - LightDirection * 3000;

float4 GetLightPos(float3 WPos)
{

	float LYZFlag = step(0.999, pow(LightDirection.y, 2));

	float3 LCrossX = normalize(cross(LightDirection, float3(0.0, LYZFlag, 1.0 - LYZFlag)));

	float3 LCrossY = normalize(cross(LightDirection, LCrossX));

	float4 XYZ = 0;

	float3 WLL=(WPos - PosL);
	XYZ.z = dot(LightDirection, WLL);
	XYZ.x = dot(LCrossX, WLL);
	XYZ.y = dot(LCrossY, WLL);

	XYZ.xy /= 256 * ShSi;


	XYZ.z = (XYZ.z - 500) / (6000 - 500);


	XYZ.w = 1;
	return XYZ;
}



float4x4 WorldViewProjMatrix      : WORLDVIEWPROJECTION;
float4x4 WorldMatrix              : WORLD;
float4x4 LightWorldViewProjMatrix : WORLDVIEWPROJECTION < string Object = "Light"; >;

float3   LightPosition     : POSITION  < string Object = "Light"; >;
float3   LightSpecular     : SPECULAR  < string Object = "Light"; >;
static float3 LightColor = LightSpecular * 10;
float4   MaterialDiffuse   : DIFFUSE  < string Object = "Geometry"; >;
float3   MaterialAmbient   : AMBIENT  < string Object = "Geometry"; >;
float3   MaterialEmmisive  : EMISSIVE < string Object = "Geometry"; >;
float    SpecularPower : SPECULARPOWER < string Object = "Geometry"; >;

static float3 MColor2= MaterialEmmisive+MaterialAmbient;
static float3 MColor=pow(MColor2,max(1.0,SpecularPower*0.01));

// テクスチャ材質モーフ値
float4   TextureAddValue   : ADDINGTEXTURE;
float4   TextureMulValue   : MULTIPLYINGTEXTURE;
float4   SphereAddValue    : ADDINGSPHERETEXTURE;
float4   SphereMulValue    : MULTIPLYINGSPHERETEXTURE;
sampler MMDSamp0 : register(s0);
sampler MMDSamp1 : register(s1);
sampler MMDSamp2 : register(s2);


texture ObjectTexture: MATERIALTEXTURE;
sampler ObjTexSampler = sampler_state {
	texture = <ObjectTexture>;
	MINFILTER =LINEAR;
	MAGFILTER =LINEAR;
	MIPFILTER = NONE;
	ADDRESSU = WRAP;
	ADDRESSV = WRAP;
};


struct VS_OUTPUT
{
	float4 Pos        : POSITION;    
	float2 Tex		  : TEXCOORD0;	
	float4 PPos       : TEXCOORD1;
	float3  WPos       : TEXCOORD2;
};

VS_OUTPUT Basic_VS(float4 Pos : POSITION, float2 Tex : TEXCOORD0)
{
	VS_OUTPUT Out = (VS_OUTPUT)0;
    Pos.xyz+=YurePos(Tex,Pos.xyz);
	//Out.Pos = mul(Pos, LightWorldViewProjMatrix);
	float4 WPos = mul(Pos, WorldMatrix);
	Out.Pos=GetLightPos(WPos.rgb);
	Out.WPos=WPos.xyz;
	Out.Tex = Tex;
	Out.PPos = Out.Pos;


	return Out;
}

float4 Basic_PS(VS_OUTPUT IN,uniform bool useTexture) : COLOR0
{	

	float4 Color=1.0;
	Color.rgb *=saturate(min(length(MColor),1.8)*normalize(MColor));
	if ( useTexture ) {
	float4 TexColor = tex2D(ObjTexSampler, IN.Tex);
	TexColor.rgb = lerp(1, TexColor.rgb * TextureMulValue.rgb + TextureAddValue.rgb, TextureMulValue.a + TextureAddValue.a);
	Color *= TexColor;
	}
	float a = Color.a*MaterialDiffuse.a;
	clip(a - 0.1);

	Color.rgba=1.0;
	Color.r =IN.PPos.z;
	return Color;
}

// オブジェクト描画用テクニック
technique MainTec < string MMDPass = "object"; bool UseTexture = true;> {
	pass DrawObject
	{
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 Basic_VS();
		PixelShader = compile ps_3_0 Basic_PS(true);
	}
}
technique MainTec2 < string MMDPass = "object"; bool UseTexture = false;> {
	pass DrawObject
	{
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 Basic_VS();
		PixelShader = compile ps_3_0 Basic_PS(false);
	}
}
// オブジェクト描画用テクニック
technique MainTecBS  < string MMDPass = "object_ss"; bool UseTexture = true;> {
	pass DrawObject {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 Basic_VS();
		PixelShader = compile ps_3_0 Basic_PS(true);
	}
}
technique MainTecBS2 < string MMDPass = "object_ss"; bool UseTexture = false;> {
	pass DrawObject
	{
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 Basic_VS();
		PixelShader = compile ps_3_0 Basic_PS(false);
	}
}
technique EdgeTec < string MMDPass = "edge"; > {

}
technique ShadowTech < string MMDPass = "shadow";  > {

}
technique ZplotTec	< string MMDPass = "zplot"; >{

}	


///////////////////////////////////////////////////////////////////////////////////////////////